#include <stdio.h>
#include <string.h>
#include <vector>

using namespace std;

#define MAX_N 20005
#define INF 0x3f3f3f3f
#define FIN "pioni.in"
#define FOUT "pioni.out"

int T, N, M, K, moves[MAX_N];
vector<int> G[MAX_N];

int solve(int n)
{
    int &ret = moves[n], win = 0;
    vector<int>::iterator it;

    if (ret != INF) return ret;
    for (it = G[n].begin(); it != G[n].end(); ++it)
    {
        int t = solve(*it);
        if (!(t%2) && (!win || ret < t+1)) 
            ret = t+1, win = 1;
        else
        if (t%2 && !win && ret > t+1)
            ret = t+1;
    }
    if (ret == INF) ret = 0;
    return ret;
}

int main(void)
{
    int i, j, x, bst;

    freopen(FIN, "r", stdin);
    freopen(FOUT, "w", stdout);

    memset(moves, 0x3f, sizeof(moves));
    for (scanf("%d %d %d", &T, &N, &M); M; --M)
    {
        scanf("%d %d", &i, &j);
        G[i].push_back(j);
    }

    for (; T; --T) 
    {
        scanf("%d", &K); 
        for (bst = -INF, i = 0; i < K; ++i)
        {
            scanf("%d", &x);
            bst = max(bst, solve(x));
        }
        printf("%s\n", bst&1 ? "Nargy" : "Fumeanu");
    }

    return 0;
}
